package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.OrderAddressService;
import com.gxwebsoft.shop.entity.OrderAddress;
import com.gxwebsoft.shop.param.OrderAddressParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 订单收货地址记录表控制器
 *
 * @author 科技小王子
 * @since 2022-12-02 21:21:10
 */
@Api(tags = "订单收货地址记录表管理")
@RestController
@RequestMapping("/api/shop/order-address")
public class OrderAddressController extends BaseController {
    @Resource
    private OrderAddressService orderAddressService;

    @PreAuthorize("hasAuthority('shop:orderAddress:list')")
    @OperationLog
    @ApiOperation("分页查询订单收货地址记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<OrderAddress>> page(OrderAddressParam param) {
        PageParam<OrderAddress, OrderAddressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(orderAddressService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(orderAddressService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:list')")
    @OperationLog
    @ApiOperation("查询全部订单收货地址记录表")
    @GetMapping()
    public ApiResult<List<OrderAddress>> list(OrderAddressParam param) {
        PageParam<OrderAddress, OrderAddressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(orderAddressService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(orderAddressService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:list')")
    @OperationLog
    @ApiOperation("根据id查询订单收货地址记录表")
    @GetMapping("/{id}")
    public ApiResult<OrderAddress> get(@PathVariable("id") Integer id) {
        return success(orderAddressService.getById(id));
        // 使用关联查询
        //return success(orderAddressService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:save')")
    @OperationLog
    @ApiOperation("添加订单收货地址记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OrderAddress orderAddress) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          orderAddress.setUserId(loginUser.getUserId());
          orderAddress.setMerchantCode(getMerchantCode());
        }
        if (orderAddressService.save(orderAddress)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:update')")
    @OperationLog
    @ApiOperation("修改订单收货地址记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OrderAddress orderAddress) {
        if (orderAddressService.updateById(orderAddress)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:remove')")
    @OperationLog
    @ApiOperation("删除订单收货地址记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (orderAddressService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:save')")
    @OperationLog
    @ApiOperation("批量添加订单收货地址记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OrderAddress> list) {
        if (orderAddressService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:update')")
    @OperationLog
    @ApiOperation("批量修改订单收货地址记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OrderAddress> batchParam) {
        if (batchParam.update(orderAddressService, "order_address_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:orderAddress:remove')")
    @OperationLog
    @ApiOperation("批量删除订单收货地址记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (orderAddressService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
